import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { CmsArticleLike, CmsArticleLikeParam } from './model';


/**
 * 分页查询点赞文章
 */
export async function pageCmsArticleLike(params: CmsArticleLikeParam) {
  const res = await request.get<ApiResult<PageResult<CmsArticleLike>>>(
    '/cms/cms-article-like/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询点赞文章列表
 */
export async function listCmsArticleLike(params?: CmsArticleLikeParam) {
  const res = await request.get<ApiResult<CmsArticleLike[]>>(
    '/cms/cms-article-like',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加点赞文章
 */
export async function addCmsArticleLike(data: CmsArticleLike) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-article-like',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改点赞文章
 */
export async function updateCmsArticleLike(data: CmsArticleLike) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-article-like',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除点赞文章
 */
export async function removeCmsArticleLike(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-article-like/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除点赞文章
 */
export async function removeBatchCmsArticleLike(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-article-like/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询点赞文章
 */
export async function getCmsArticleLike(id: number) {
  const res = await request.get<ApiResult<CmsArticleLike>>(
    '/cms/cms-article-like/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
